<script context="module" lang="ts">
    import type { LoadInput, LoadOutput } from '@sveltejs/kit/types/page'

    export const prerender = true

    export function load({ page }: LoadInput): LoadOutput {
        const token = page.query.get('token')

        if (!token)
            return {
                status: 302,
                redirect: '/forgot-password'
            }

        return {
            props: {
                token
            }
        }
    }
</script>

<script lang="ts">
    import zxcvbn from 'zxcvbn'
    import { post } from '$lib/fetch'
    import defaultInputs from '$lib/defaultPasswordInputs'
    import Alert from '$components/Alert.svelte'
    import Authentication from '$components/Layouts/Authentication.svelte'
    import Input from '$components/Form/Input.svelte'
    import PasswordMeter from '$components/PasswordMeter.svelte'

    export let token: string

    let email: string
    let password: string
    let password_confirmation: string
    let errors = {
        email: [],
        username: [],
        password: [],
        password_confirmation: [],
        message: undefined
    }
    let successMessage: string

    let passwordInputs: string[]
    $: passwordInputs = [...defaultInputs, email]

    $: results = password ? zxcvbn(password, passwordInputs) : undefined

    const submit = async () => {
        if (results?.score < 2) return

        const { req, res } = await post('reset-password', {
            token,
            email,
            password,
            password_confirmation
        })
        if (req.ok) {
            successMessage = res
        } else {
            errors = res.errors
        }
    }
</script>

<Authentication btnLabel="Mettre à jour" title="Réinitialiser mon mot de passe" on:submit={submit}>
    {#if successMessage}
        <Alert variant="success">
            <h2 slot="title">Super !</h2>
            <p>{successMessage}</p>
        </Alert>
    {/if}
    {#if errors.message}
        <Alert variant="error">
            <h2 slot="title">Oops !</h2>
            <p>{errors.message}</p>
        </Alert>
    {/if}
    <Input bind:value={email} errors={errors.email} name="email" type="email">
        Email du compte
    </Input>
    <Input bind:value={password} errors={errors.password} name="password" type="password">
        Nouveau mot de passe
        <small slot="tooltip">
            <PasswordMeter {results} />
        </small>
    </Input>
    <Input
        bind:value={password_confirmation}
        errors={errors.password_confirmation}
        name="password"
        type="password"
    >
        Confirmation du mot de passe
    </Input>
    <slot slot="bottomUrl"><a href="login">Retour à la connexion</a></slot>
</Authentication>
